// LiteLoader-AIDS automatic generated
/// <reference path="c:\Users\CatMoyuer\Tool\Github\LiteloaderSE-Aids/dts/helperlib/src/index.d.ts"/> 

ll.registerPlugin(
    /* name */ "ScoreboardGUI",
    /* introduction */ "使用GUI来管理计分板",
    /* version */ [1, 2, 0],
    /* otherInformation */ {}
);

mc.regPlayerCmd("scoreboardgui", "打开计分板管理界面", function(player, args) {
    if (player.isOP()) {
        openMainMenu(player);
    } else {
        player.tell("你没有权限使用此命令！");
    }
});

function openMainMenu(player) {
    var fm = mc.newSimpleForm();
    fm.setTitle("计分板管理");
    fm.setContent("请选择一个操作：");
    fm.addButton("管理计分板");
    fm.addButton("管理玩家分数");

    player.sendForm(fm, function(player, id) {
        if (id === 0) {
            openScoreboardMenu(player);
        } else if (id === 1) {
            openPlayerScoreMenu(player);
        }
    });
}

function openScoreboardMenu(player) {
    var fm = mc.newSimpleForm();
    fm.setTitle("计分板管理");
    fm.setContent("请选择一个操作：");
    fm.addButton("创建计分板");
    fm.addButton("删除计分板");
    fm.addButton("查看所有计分板");
    fm.addButton("设置计分板显示状态");
    fm.addButton("返回");

    player.sendForm(fm, function(player, id) {
        if (id === 0) {
            openCreateScoreboardForm(player);
        } else if (id === 1) {
            openDeleteScoreboardForm(player);
        } else if (id === 2) {
            openListScoreboardsForm(player);
        } else if (id === 3) {
            openSetDisplayForm(player);
        } else if (id === 4) {
            openMainMenu(player);
        }
    });
}

function openPlayerScoreMenu(player) {
    var fm = mc.newSimpleForm();
    fm.setTitle("管理玩家分数");
    fm.setContent("请选择一个操作：");
    fm.addButton("设置玩家分数");
    fm.addButton("增加玩家分数");
    fm.addButton("减少玩家分数");
    fm.addButton("重置玩家分数");
    fm.addButton("返回");

    player.sendForm(fm, function(player, id) {
        if (id === 0) {
            openSetPlayerScoreForm(player);
        } else if (id === 1) {
            openAddPlayerScoreForm(player);
        } else if (id === 2) {
            openReducePlayerScoreForm(player);
        } else if (id === 3) {
            openDeletePlayerScoreForm(player);
        } else if (id === 4) {
            openMainMenu(player);
        }
    });
}

function openCreateScoreboardForm(player) {
    var fm = mc.newCustomForm();
    fm.setTitle("创建计分板");
    fm.addInput("计分板名称", "请输入计分板名称");
    fm.addInput("显示名称", "请输入显示名称");

    player.sendForm(fm, function(player, data) {
        if (data !== null) {
            var name = data[0];
            var displayName = data[1];
            if (name && displayName) {
                var obj = mc.newScoreObjective(name, displayName);
                if (obj !== null) {
                    player.tell("计分板创建成功！");
                } else {
                    player.tell("计分板创建失败！");
                }
            } else {
                player.tell("请输入有效的名称和显示名称！");
            }
        }
        openScoreboardMenu(player);
    });
}

function openDeleteScoreboardForm(player) {
    var fm = mc.newSimpleForm();
    fm.setTitle("删除计分板");
    fm.setContent("请选择要删除的计分板：");

    var objectives = mc.getAllScoreObjectives();
    objectives.forEach(function(obj) {
        fm.addButton(obj.displayName);
    });
    fm.addButton("返回");

    player.sendForm(fm, function(player, id) {
        if (id !== null && id < objectives.length) {
            var obj = objectives[id];
            if (mc.removeScoreObjective(obj.name)) {
                player.tell("计分板删除成功！");
            } else {
                player.tell("计分板删除失败！");
            }
        }
        openScoreboardMenu(player);
    });
}

function openListScoreboardsForm(player) {
    var fm = mc.newSimpleForm();
    fm.setTitle("所有计分板");
    fm.setContent("以下是所有计分板：");

    var objectives = mc.getAllScoreObjectives();
    objectives.forEach(function(obj) {
        fm.addButton(obj.displayName + " (" + obj.name + ")");
    });
    fm.addButton("返回");

    player.sendForm(fm, function(player, id) {
        if (id !== null && id < objectives.length) {
            var obj = objectives[id];
            openScoreboardDetailsForm(player, obj);
        } else {
            openScoreboardMenu(player);
        }
    });
}

function openScoreboardDetailsForm(player, obj) {
    var fm = mc.newSimpleForm();
    fm.setTitle("计分板详情 - " + obj.displayName);
    fm.setContent("前10名玩家：");

    var scores = [];
    var players = mc.getOnlinePlayers();
    players.forEach(function(pl) {
        var score = obj.getScore(pl);
        if (score !== null) {
            scores.push({ name: pl.name, score: score });
        }
    });

    scores.sort(function(a, b) {
        return b.score - a.score;
    });

    for (var i = 0; i < Math.min(10, scores.length); i++) {
        fm.addButton(scores[i].name + ": " + scores[i].score);
    }
    fm.addButton("返回");

    player.sendForm(fm, function(player, id) {
        openListScoreboardsForm(player);
    });
}

function openSetDisplayForm(player) {
    var fm = mc.newSimpleForm();
    fm.setTitle("设置计分板显示状态");
    fm.setContent("请选择要显示的计分板：");

    var objectives = mc.getAllScoreObjectives();
    objectives.forEach(function(obj) {
        fm.addButton(obj.displayName);
    });
    fm.addButton("返回");

    player.sendForm(fm, function(player, id) {
        if (id !== null && id < objectives.length) {
            var obj = objectives[id];
            openSetDisplaySlotForm(player, obj);
        } else {
            openScoreboardMenu(player);
        }
    });
}

function openSetDisplaySlotForm(player, obj) {
    var fm = mc.newCustomForm();
    fm.setTitle("设置显示状态");
    fm.addDropdown("请选择显示槽位：", ["sidebar", "belowname", "list", "取消显示"]);
    fm.addDropdown("排序方式", ["升序", "降序"]);

    player.sendForm(fm, function(player, data) {
        if (data !== null) {
            var slotId = data[0];
            var sortOrder = data[1]; // 0 或 1
            var slots = ["sidebar", "belowname", "list"];
            if (slotId < 3) {
                var slot = slots[slotId];
                if (obj.setDisplay(slot, sortOrder)) {
                    player.tell("计分板显示状态设置成功！");
                } else {
                    player.tell("计分板显示状态设置失败！");
                }
            } else if (slotId === 3) {
                var success = false;
                slots.forEach(function(slot) {
                    if (mc.clearDisplayObjective(slot)) {
                        success = true;
                    }
                });
                if (success) {
                    player.tell("计分板显示已取消！");
                } else {
                    player.tell("取消计分板显示失败！");
                }
            }
        }
        openScoreboardMenu(player);
    });
}

function openSetPlayerScoreForm(player) {
    var fm = mc.newCustomForm();
    fm.setTitle("设置玩家分数");

    var players = mc.getOnlinePlayers().map(p => p.name);
    var objectives = mc.getAllScoreObjectives().map(o => o.name);

    fm.addDropdown("请选择玩家：", players);
    fm.addDropdown("请选择计分板：", objectives);
    fm.addInput("分数", "请输入分数", "0");

    player.sendForm(fm, function(player, data) {
        if (data !== null) {
            var players = mc.getOnlinePlayers().map(p => p.name);
            var objectives = mc.getAllScoreObjectives().map(o => o.name);
            var playerName = players[data[0]];
            var scoreboardName = objectives[data[1]];
            var score = parseInt(data[2]);
            var targetPlayer = mc.getPlayer(playerName);
            if (targetPlayer) {
                var obj = mc.getScoreObjective(scoreboardName);
                if (obj) {
                    obj.addScore(targetPlayer, 0);
                    obj.setScore(targetPlayer, score);
                    player.tell("玩家分数设置成功！");
                } else {
                    player.tell("计分板不存在！");
                }
            } else {
                player.tell("玩家不存在！");
            }
        }
        openPlayerScoreMenu(player);
    });
}

function openAddPlayerScoreForm(player) {
    var fm = mc.newCustomForm();
    fm.setTitle("增加玩家分数");

    var players = mc.getOnlinePlayers().map(p => p.name);
    var objectives = mc.getAllScoreObjectives().map(o => o.name);

    fm.addDropdown("请选择玩家：", players);
    fm.addDropdown("请选择计分板：", objectives);
    fm.addInput("增加的分数", "请输入增加的分数", "0");

    player.sendForm(fm, function(player, data) {
        if (data !== null) {
            var players = mc.getOnlinePlayers().map(p => p.name);
            var objectives = mc.getAllScoreObjectives().map(o => o.name);
            var playerName = players[data[0]];
            var scoreboardName = objectives[data[1]];
            var score = parseInt(data[2]);
            var targetPlayer = mc.getPlayer(playerName);
            if (targetPlayer) {
                var obj = mc.getScoreObjective(scoreboardName);
                if (obj) {
                    obj.addScore(targetPlayer, 0);
                    obj.addScore(targetPlayer, score);
                    player.tell("玩家分数增加成功！");
                } else {
                    player.tell("计分板不存在！");
                }
            } else {
                player.tell("玩家不存在！");
            }
        }
        openPlayerScoreMenu(player);
    });
}

function openReducePlayerScoreForm(player) {
    var fm = mc.newCustomForm();
    fm.setTitle("减少玩家分数");

    var players = mc.getOnlinePlayers().map(p => p.name);
    var objectives = mc.getAllScoreObjectives().map(o => o.name);

    fm.addDropdown("请选择玩家：", players);
    fm.addDropdown("请选择计分板：", objectives);
    fm.addInput("减少的分数", "请输入减少的分数", "0");

    player.sendForm(fm, function(player, data) {
        if (data !== null) {
            var players = mc.getOnlinePlayers().map(p => p.name);
            var objectives = mc.getAllScoreObjectives().map(o => o.name);
            var playerName = players[data[0]];
            var scoreboardName = objectives[data[1]];
            var score = parseInt(data[2]);
            var targetPlayer = mc.getPlayer(playerName);
            if (targetPlayer) {
                var obj = mc.getScoreObjective(scoreboardName);
                if (obj) {
                    obj.addScore(targetPlayer, 0);
                    obj.reduceScore(targetPlayer, score);
                    player.tell("玩家分数减少成功！");
                } else {
                    player.tell("计分板不存在！");
                }
            } else {
                player.tell("玩家不存在！");
            }
        }
        openPlayerScoreMenu(player);
    });
}

function openDeletePlayerScoreForm(player) {
    var fm = mc.newCustomForm();
    fm.setTitle("重置玩家分数");
    
    var players = mc.getOnlinePlayers().map(p => p.name);
    var objectives = mc.getAllScoreObjectives().map(o => o.name);
    
    fm.addDropdown("请选择玩家：", players);
    fm.addDropdown("请选择计分板：", objectives);
    
    player.sendForm(fm, function(player, data) {
        if (data !== null) {
            var playerName = players[data[0]];
            var scoreboardName = objectives[data[1]];
            var targetPlayer = mc.getPlayer(playerName);
            if (targetPlayer) {
                var obj = mc.getScoreObjective(scoreboardName);
                if (obj) {
                    obj.addScore(targetPlayer, 0);
                    obj.deleteScore(targetPlayer);
                    player.tell("玩家分数重置成功！");
                } else {
                    player.tell("计分板不存在！");
                }
            } else {
                player.tell("玩家不存在！");
            }
        }
        openPlayerScoreMenu(player);
    });
}